---
title: RTCRtpCapabilities
slug: Web/API/RTCRtpCapabilities
tags:
  - API
  - Audio
  - Codec
  - Dictionary
  - Media
  - Negotiation
  - RTCRtpCapabilities
  - RTP
  - Reference
  - Video
  - WebRTC
  - WebRTC API
  - WebRTC Device API
---
<p>{{DefaultAPISidebar("WebRTC")}}</p>

<p>The <code><strong>RTCRtpCapabilities</strong></code> dictionary is a data type used to describe the capabilities of an {{domxref("RTCRtpSender")}} or {{domxref("RTCRtpReceiver")}} in response to a call to the {{domxref("RTCRtpSender.getCapabilities()")}} or {{domxref("RTCRtpReceiver.getCapabilities()")}} static functions, both of which return an array of <code>RTCRtpCapabilities</code> objects.</p>

<p>An <code>RTCRtpCapabilities</code> object contains an array of objects conforming to {{domxref("RTCRtpCodecCapability")}} (each describing the capabilities of one codec) and an array of the supported {{Glossary("RTP")}} <a href="https://tools.ietf.org/html/rfc3550#section-5.3.1">header extensions</a> for that codec.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>codecs</code></dt>
 <dd>An array of {{domxref("RTCRtpCodecCapability")}} objects, each describing one of the codecs supported by the {{domxref("RTCRtpSender")}} or {{domxref("RTCRtpReceiver")}}. There are some special entries in this array, described below in the section {{anch("The codecs array")}}.</dd>
 <dt><code>headerExtensions</code></dt>
 <dd>An array of objects conforming to the {{domxref("RTCRtpHeaderExtensionCapability")}} dictionary. Each object contains a single {{domxref("DOMString")}}, <code>uri</code>, specifying the URI of the header extension, as described in {{RFC(5285)}}.</dd>
</dl>

<h2 id="Description">Description</h2>

<h3 id="The_codecs_array">The codecs array</h3>

<p>The <code>codecs</code> array is an array of objects conforming to the dictionary {{domxref("RTCRtpCodecCapability")}}. Each of these objects describes a single codec and its basic capabilities. Its properties are:</p>

<p>{{page("/en-US/docs/Web/API/RTCRtpCodecCapabilities", "Properties")}}</p>

<p>The browser will only report distinct capability combinations separately. If two sets of capabilities can be described as one, they will be. That means that, for instance, if there are two entries for the H.264 codec (as identified by the {{domxref("RTCRtpCodecCapabilities.mimeType", "mimeType")}} being "video/H264"), there are other values in the capabilities objects indicating how they're different in some way.</p>

<div class="notecard note">
<p>The MIME type strings used by RTP differ from those used elsewhere. See {{RFC(3555, "", 4)}} for the complete IANA registry of these types.</p>
</div>

<p>There are three special entries that should always be present, representing underlying components of the transport. Those components are:</p>

<dl>
 <dt>RED (REDundant Audio Data)</dt>
 <dd>The media type of an RED entry may vary due to there being several versions of it, but it will end with <code>red</code>, such as <code>video/red</code> or <code>video/fwdred</code>. The base RED standard can be found in {{RFC(2198)}}. There may be multiple entries for RED if different forms are supported; each will have a unique media type in that case.</dd>
 <dt>FEC (Forward Error Correction)</dt>
 <dd>An FEC component handles error correction data; its media type may also vary due to there being advanced versions of the standard available, but it will always end with <code>fec</code>. One possible value is <code>video/ulpfec</code> (a generic error connection model). There may also be multiple FEC entries if more than one form is supported.</dd>
 <dt>RTX (Retransmission)</dt>
 <dd>This component is responsible for retransmission of data; it's media type should be <code>video/rtx</code>. There will only be one entry for RTX, and it will not have an {{domxref("RTCRtpCodecCapability.sdpFmtpLine", "sdpFmtpLine")}} property.</dd>
</dl>

<p>Don't be surprised to see these show up ijn the list; be prepared to ignore them if you're only interested in the actual codecs used for the media itself.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("WebRTC 1.0", "#rtcrtpcapabilities", "RTCRtpCapabilities")}}</td>
   <td>{{Spec2("WebRTC 1.0")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCRtpCapabilities")}}</p>
</div>
